<?php 
/**
 * Continuous rss scrolling
 *
 * @package Continuous rss scrolling
 * @subpackage Continuous rss scrolling
 * @version   2.0 August, 2011
 * @author    Gopi http://www.gopiplus.com
 * @copyright Copyright (C) 2010 - 2011 www.gopiplus.com, LLC
 * @license   http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 *
 */
 
 defined('_JEXEC') or die('Restricted access'); ?>

<script language="JavaScript1.2">
function crs_scroll() {
	crs_obj.scrollTop = crs_obj.scrollTop + 1;
	crs_scrollPos++;
	if ((crs_scrollPos%crs_heightOfElm) == 0) {
		crs_numScrolls--;
		if (crs_numScrolls == 0) {
			crs_obj.scrollTop = '0';
			crs_content();
		} else {
			if (crs_scrollOn == 'true') {
				crs_content();
			}
		}
	} else {
		setTimeout("crs_scroll();", 10);
	}
}
var crs_Num = 0;
function crs_content() {
	var tmp_vsrp = '';

	w_vsrp = crs_Num - parseInt(crs_numberOfElm);
	if (w_vsrp < 0) {
		w_vsrp = 0;
	} else {
		w_vsrp = w_vsrp%crs_array.length;
	}
	
	// Show amount of vsrru
	var elementsTmp_vsrp = parseInt(crs_numberOfElm) + 1;
	for (i_vsrp = 0; i_vsrp < elementsTmp_vsrp; i_vsrp++) {
		
		tmp_vsrp += crs_array[w_vsrp%crs_array.length];
		w_vsrp++;
	}

	crs_obj.innerHTML 	= tmp_vsrp;
	
	crs_Num 			= w_vsrp;
	crs_numScrolls 	= crs_array.length;
	crs_obj.scrollTop 	= '0';
	// start scrolling
	setTimeout("crs_scroll();", 2000);
}
</script>

<?php
		
	@$crs_record_height=$params->get('crs_record_height');
	@$crs_display_count=$params->get('crs_display_count');
	@$crs_display_width=$params->get('crs_display_width');
	@$crs_rss_url=$params->get('crs_rss_url');
	
	if(!is_numeric(@$crs_display_width))
	{
		@$crs_display_width = 200;
	} 
	if(!is_numeric(@$crs_record_height))
	{
		@$crs_record_height = 30;
	}
	if(!is_numeric(@$crs_display_count))
	{
		@$crs_display_count = 5;
	}

	if(@$crs_rss_url == "")
	{
		@$url = "http://music.msn.com/rss/entnews/";
	}
	else
	{
		@$url = @$crs_rss_url;
	}

	//echo @$url;
	$xml = "";
	$cnt=0;
	$f = fopen( $url, 'r' );
	while( $data = fread( $f, 4096 ) ) { $xml .= $data; }
	fclose( $f );
	preg_match_all( "/\<item\>(.*?)\<\/item\>/s", $xml, $itemblocks );
	
	@$cnt=0;
	//print_r($itemblocks);
	if ( ! empty($itemblocks) ) 
	{
		@$crs_count = 0;
		foreach( $itemblocks[1] as $block )
		{
			
			preg_match_all( "/\<title\>(.*?)\<\/title\>/",  $block, $title );
			preg_match_all( "/\<link\>(.*?)\<\/link\>/", $block, $link );
			
			$crs_post_title = $title[1][0];
			$crs_post_title = mysql_real_escape_string(trim($crs_post_title));
			$get_permalink = $link[1][0];
			$get_permalink = mysql_real_escape_string(trim($get_permalink));
			
			$crs_post_title = substr($crs_post_title, 0, $crs_display_width);

			$dis_height = $crs_record_height."px";
			@$crs_html = @$crs_html . "<div class='crs_div' style='height:$dis_height;padding:2px 0px 2px 0px;'>"; 
			@$crs_html = @$crs_html . "<a href='$get_permalink'>$crs_post_title</a>";
			@$crs_html = @$crs_html . "</div>";
			
			$crs_post_title = trim($crs_post_title);
			$get_permalink = $get_permalink;
			@$crs_x = @$crs_x . "crs_array[$crs_count] = '<div class=\'crs_div\' style=\'height:$dis_height;padding:2px 0px 2px 0px;\'><a href=\'$get_permalink\'>$crs_post_title</a></div>'; ";	
			@$crs_count++;
			
		}
		$crs_record_height = $crs_record_height + 4;
		if($crs_count >= $crs_display_count)
		{
			$crs_count = $crs_display_count;
			$crs_height = ($crs_record_height * $crs_display_count);
		}
		else
		{
			$crs_count = $crs_count;
			$crs_height = ($crs_count*$crs_record_height);
		}
		$crs_height1 = $crs_record_height."px";
		?>
		<div style="padding-top:8px;padding-bottom:8px;">
		  <div style="text-align:left;vertical-align:middle;text-decoration: none;overflow: hidden; position: relative; margin-left: 1px; height: <?php echo $crs_height1; ?>;" id="crs_Holder"><?php echo @$crs_html; ?></div>
		</div>
		<script type="text/javascript">
		var crs_array	= new Array();
		var crs_obj	= '';
		var crs_scrollPos 	= '';
		var crs_numScrolls	= '';
		var crs_heightOfElm = '<?php echo $crs_record_height; ?>'; // Height of each element (px)
		var crs_numberOfElm = '<?php echo $crs_count; ?>';
		var crs_scrollOn 	= 'true';
		function crs_createscroll() 
		{
			<?php echo $crs_x; ?>
			crs_obj	= document.getElementById('crs_Holder');
			crs_obj.style.height = (crs_numberOfElm * crs_heightOfElm) + 'px'; // Set height of DIV
			crs_content();
		}
		</script>
		<script type="text/javascript">
		crs_createscroll();
		</script>
		<?php
	}
?>